# How to use with temperature-controller chamber

To use the temperatur-controlled chambers, following steps have to be taken. Please note the difference in MQTT broker usage when using a single or multiple chambers.

## Broker for single chamber

When using a single chamber, only one MQTT broker is required. Therefore using mosquitto_master.conf is sufficient. However, two could also be used, if you want to use the same architecture in both cases.

```
mosquitto -c mosquitto_master.conf
```

## Broker for multiple chambers

When using more than one chamber, a master broker should be used as in the previous chapter, that connects all chambers. Each chamber will have their own, local MQTT broker that can be started with, which connects to the master broker.

```
mosquitto -c mosquitto_slave.conf
```

Make sure to edit the configuration accordingly:

- Set `remote_clientid`
- Set host and port in `address`
- Set connection name (optional)

## How to use a temperature-controlled chamber

How to use the chambers...

### Requirements

To start the chamber, check out the git and install both `mosquitto` and the required python packages:

```
apt install mosquitto
pip3 install -r requirements.txt
```

### Usage

To start the chamber simply run the following command:

```
python3 -u module_loader.py [-vvvv] ChamberController [MODULES ...]
```

Depending on the sensors used in your setup, at least on of `SHT21` and `DS1820` should be included in the module list. Make sure you create a configuration file (modules.conf) to configure the ambient and chamber's temperature sensors.

NOTE: Instead of an ambient temperature sensor, you can also specify `AmbientTemperature`. See modules below for additional configuration options.

```ini
[CHAMBER]
ChamberTemperatureTopic = sht21/<host>/temp
AmbientTemperatureTopic = ds1820/<host>/<sensor_id>/temp
AmbientTemperature = 40.0
```

# Modules

This chapter describes the various modules.

## ChamberController

TODO

### Configuration

```ini
[CHAMBER]
ChamberTemperatureTopicPrefix = sht21/<host>/
AmbientTemperatureTopicPrefix = ds1820/<host>/<sensor_id>/
AmbientTemperature = 40.0
Republish = yes
```

### Topics

`chamber/<host>/target` - Set the target temperature

`chamber/<host>/temp` - Temperature of the chamber (republishes the ChamberTemperatureTopic, only if Republish=yes)
`chamber/<host>/humidity` - see above.

## SHT21

```ini
[SHT21]
```

TODO

### Configuration

### Topics

## DS1820

TODO

### Configuration


```ini
[DS1820]
```

### Topics

## HotPlug

TODO

### Configuration


```ini
[HotPlug]
```

### Topics